Ruby - Bug #15018

NODE_ARGSCAT is not parsed properly
08/22/2018 12:10 PM - chopraanmol1 (Anmol Chopra)

Status: Closed
Priority: Normal
Assignee:

Target version:

ruby -v: ruby 2.6.0dev (2018-08-22 trunk 64505) |Backport: 2.3: UNKNOWN, 2.4: UNKNOWN, 2.5:
[x86_64-linux] UNKNOWN

Description
Instead of wrapping following arguments in one list, current implementation creates multiple list wrapping only 2 elements.

e.g.
for

[*args,1,2,3,4,5,6]

Expected AST:
NODE_ARGSCAT---nd_head—-—->NODE_SPLAT (args)
:———nd_body——>NODE_ARRAY(l,2,3,4,5,6)

Current AST:
NODE_ARGSCAT---nd_head-—>NODE_ARGSCAT--nd_head-—>NODE_ARGSCAT--nd_head-->NODE_SPLAT (args)

\ |
\ | =——-nd_body-->NODE_ARRAY (1, 2)

\
| ———nd_body—-—->NODE_ARRAY (3, 4)

[
|
[
I
| ~———nd_body-—->NODE_ARRAY (5, 6)

Current Implementation result into something like
args + [1,2] + [3,4] + [5,6]

instead of

args + [1,2,3,4,5,6]

Benchmark result

With patch:

user system total real
argscat 0.556000 0.000000 0.556000 ( 0.553981)
argscat_multiple 2.372000 0.000000 2.372000 ( 2.373701)
Trunk:

user system total real
argscat 1.656000 0.000000 1.656000 ( 1.655868)
argscat_multiple 6.232000 0.000000 6.232000 ( 6.234846)

Implementation:
https://github.com/ruby/ruby/pull/1940

Associated revisions

Revision fad01941b3239faa4756c9f2db00fca00a786063 - 08/22/2018 03:04 PM - mame (Yusuke Endoh)
parse.y (arg_append): support NODE_ARGSCAT case
https://github.com/ruby/ruby/pull/1940

Because of the lack of this case, [*ary,1,2,3,4,5,6] was parsed into
an inefficient AST like ary + [1,2] + [3,4] + [5,6].

A patch from Anmol Chopra anmolchopra@rocketbox.in.
Fixes [Bug #15018].

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@64510 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision fad01941b3239faa4756¢c9f2db00fca00a786063 - 08/22/2018 03:04 PM - mame (Yusuke Endoh)

parse.y (arg_append): support NODE_ARGSCAT case

Because of the lack of this case, [*ary,1,2,3,4,5,6] was parsed into
an inefficient AST like ary + [1,2] + [3,4] + [5,6].

A patch from Anmol Chopra anmolchopra@rocketbox.in.
Fixes [Bug #15018].

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@64510 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision fad01941 - 08/22/2018 03:04 PM - mame (Yusuke Endoh)
parse.y (arg_append): support NODE_ARGSCAT case

Because of the lack of this case, [*ary,1,2,3,4,5,6] was parsed into
an inefficient AST like ary + [1,2] + [3,4] + [5,6].

A patch from Anmol Chopra anmolchopra@rocketbox.in.
Fixes [Bug #15018].

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@64510 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 08/22/2018 12:15 PM - chopraanmol1 (Anmol Chopra)

- Description updated

#2 - 08/22/2018 03:04 PM - mame (Yusuke Endoh)
- Status changed from Open to Closed

Applied in changeset trunk|r64510.

parse.y (arg_append): support NODE_ARGSCAT case

Because of the lack of this case, [*ary,1,2,3,4,5,6] was parsed into
an inefficient AST like ary + [1,2] + [3,4] + [5,6].

A patch from Anmol Chopra anmolchopra@rocketbox.in.
Fixes [Bug #15018].

#3 - 08/22/2018 03:04 PM - mame (Yusuke Endoh)

Good catch! I've committed it. Thank you!

Files
bench_node_argscat.rb 524 Bytes 08/22/2018 chopraanmol1 (Anmol Chopra)
06/17/2025 2/2
